% ccode any_prio any_prio_on war_prio war_prio_on war_col war_inc war gdp_g gdp_g_l $x_fl $x_year Iccode* GPCP_g GPCP_g_l GPCP_g_l_2 NCEP_g NCEP_g_l NCEP_g_l_2 FAO_g FAO_g_l FAO_g_l_2
%small dictionary
%col (1)  - ccode          - Correlates of War (COW) Country Code (41 African countries)
%col (2)  - any_prio       - Any Internal War or Any Internationalized Internal War. 
%                            Dichotomous variable. Coded “1"? if TYPE3 equals 1, 2, or 3 or TYPE4 equals 1, 2, or 3, 
%							 “0"? otherwise.any internal war (0 or 1) >= 25 deaths.
%col (3)  - any_prio_on    - ANY_PRIO Onset. “1"? if Any Internal War or Any Internationalized Internal War onset
%                            during country year, “0"? otherwise
%col (4)  - war_prio       - Internal War or Internationalized Internal War. Internal Conflict or Internationalized
%                            Conflict with at least 1,000 battle-related deaths per year. Dichotomous variable. 
%							 Coded “1"? if TYPE3 equals 3 or TYPE4 equals 3, “0"? otherwise.
%col (5)  - war_prio_on    - WAR_PRIO Onset. Dichotomous variable. Coded “1"? if Internal War or Internationalized 
%                            Internal War onset during country year, “0"? otherwise.
%col (6)  - war_col        - Civil War Incidence using Collier and Hoeffler’s coding. Dichotomous variable. Coded “1"? 
%                            if COLWARS > 0, “0"? otherwise.
%col (7)  - war_inc        - Civil War Incidence using Doyle and Sambanis coding. Dichotomous variable. Coded “1"? if 
%                            WARSTDS = 1 or WARSTDS = Missing(.), “0"? otherwise.
%col (8)  - war            - Dichotomous variable. Coded “1"? if war ongoing during country year, “0"? otherwise. Source: 
%                            Fearon and Laitin (2003).  
%col (9)  - gdp_g          - GDP Growth. (GDPEN - GDPENL) / (GDPENL)
%col (10) - gdp_g_l        - GDP_G lagged one year
%col (11) - y0             - GDP per capita at the beginning of the period of analysis, 1979 (1990 for Namibia). 
%                            GDPEN for 1979 (1990 for Namibia)
%col (12) - polity2l       - Polity2 lagged one year, with 0 for start of country series. Source: Fearon and Laitin (2003). 
%                            Polity2 is a revised polity score. Taken from the Polity IV dataset. Polity is the difference 
%							 between Polity IV’s  measure of democracy minus its measure of autocracy. Values range from 
%							 –10 to 10. The revised polity score fills in missing values based on the following coding: 
%							 when polity = -66, set polity2 = NULL, when polity = -77, set polity2 = 0, when polity = -88, 
%							 extrapolate based previous and subsequent values. Source: Fearon and Laitin (2003)
%col (13) - ethfrac        - Ethnic-linguistic fractionalization based on the Atlas Marodov Mira.
%col (14) - relfrac        - religious fractionalization
%col (15) - oil            - oil exporters
%col (16) - lpopl1         - log of population lagged one year
%col (17) - lmtnest        - log of percent mountainous terrain. Mountainous terrain is based on work by geographer A.J. Gerard
%                            for the World Bank’s “Economics of Civil War, Crime, and Violence"? project. 
%							 Source: Fearon and Laitin (2003)
%col (18)-(58)             - country specific time trend
%col (59)-(99)             - country fixed effects
%col (100) - GPCP_g        - GPCP growth: (GPCP - GPCP_l) / (GPCP_l). GPCP Global Precipitation Climatology Project estimate
%                            of average precipitation in millimeters per year. The exact source was NASA GPCP V2. It uses the
%                            Huffman et al. (1995, 1997) method of data selection and merging.
%                            Source: Global Precipitation Climatology Project (GPCP)
%col (101) - GPCP_g_l       - lagged GPCP
%col (102) - GPCP_g_l_2     - GPCP growth lagged tow years: 
%col (103) - NCEP_g         - NCEP growth: (NCEP - NCEP_l) / (NCEP_l). National Centers for Environment Prediction (NCEP)
%							 estimate of average precipitation in millimeters per year. The exact source was NOAA NCEP 
%							 CPC Merged Analysis. It uses the Xie and Arkin (1997) method of data selection and merging. 
%							 Source: National Centers for Environment Prediction (NCEP).
%col (104) - NCEP_g_l       - NCEP growth lagged one year: (NCEP_l  - NCEP_l2) / (NCEP_l2).
%col (105) - NCEP_g_l_2     - NCEP growth lagged two years:(NCEP_l2 - NCEP_l3) / (NCEP_l3).
%col (106) - FAO_g          - FAO growth: (FAO - FAO_l) / (FAO_l). FAO Climatic (FAOCLIM2) Database estimate of average
%							 precipitation in millimeters per year. See section 2 for an explanation of the methodology
%							 used to construct this measure. Source: FAOCLIM2.            
%col (107) - FAO_g_l        - FAO growth lagged one year:   (FAO_l - FAO_l2) / (FAO_l2). 
%col (108) - FAO_g_l_2      - FAO growth lagged two  years: (FAO_l2 - FAO_l3) / (FAO_l3). 

%G  - number of clusters
%n  - total number of observations
%ct - variance covariance correction term for clustered observarions. It belongs to the Stata routine
%s  - number when starts each cluster 